<?php
namespace Teknisa\OPL\Factories;

use Doctrine\ORM\EntityManager;

class Dfs48000EntradaDoOperadorLogisticoFactory {
    #default service
    protected $connection;
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }

     public function getSerieEntr($cdSerie) {
        $sql = "SELECT CDSERIEENTR
                    FROM SERIEENTR
                WHERE CDSERIEENTR = :P_CDSERIE";
                
        $params = array("P_CDSERIE" => $cdSerie);
        
        $query = $this->connection->prepare($sql);
        $query->execute($params); 
        
        return $query->fetchAll();
    }
    
    public function deleteInicTemp($iniciTemp) {
        $sql = "DELETE INCITEMP WHERE NRINCITEMP = :P_INCITEMP";
        
        $params = array("P_INCITEMP" => $iniciTemp); 
                 
        $query = $this->connection->prepare($sql);
        $query->execute($params);
    }
    
     public function adqProdfiliEntrada($cdProduto, $cdFilial) {
        $sql = "SELECT PRODFILI.IDPRODATIV, FILIAL.CDFILIAL, FILIAL.NMFILIAL
                FROM PRODFILI INNER JOIN FILIAL ON PRODFILI.CDFILIAL = FILIAL.CDFILIAL
                WHERE PRODFILI.CDPRODUTO = :P_CDPRODUTO
                    AND FILIAL.CDFILIAL    = :P_CDFILIAL";
                
        $params = array("P_CDPRODUTO" => $cdProduto, "P_CDFILIAL" => $cdFilial);
        
        $query = $this->connection->prepare($sql);
        $query->execute($params); 
        
        return $query->fetchAll();
    }
     public function buscaProdutosOrigem($cdFilial, $nrLanctonf, $cdFildest, $tipocusto, $dtProc, $idutorigprod) {
        $sql = "SELECT CDPRODUTO,
                  CDARVPROD,
                  NMPRODUTO,
                  SUM(NVL(QTSAIDOPLOG,0)) AS QTSAIDOPLOG,
                  SUM(QTPROGENTAF)        AS QTPROGENTAF,
                  VRPREUNIAF,
                  SUM(QTNFRELAFSAI) AS QTNFRELAFSAI,
                  CDFILLANC,
                  CDFILDEST,
                  NRAUTOFORN,
                  CDMARCA,
                  DTPROGENTAF,
                  VRUNITITEM,
                  ROUND(SUM(QTNFRELAFSAI) * VRUNITITEM,2) AS VRTOTAITEM,
                  IDUTILITEM,
                  NRSEQITPROD,
                  IDORIGEMPROD
                FROM
                  (SELECT N.CDPRODUTO,
                    P.CDARVPROD,
                    P.NMPRODUTO,
                    I.QTSAIDOPLOG,
                    I.QTPROGENTAF,
                    I.VRPREUNIAF,
                    N.QTNFRELAFSAI,
                    I.CDFILLANC,
                    I.CDFILDEST,
                    I.NRAUTOFORN,
                    I.CDMARCA,
                    I.DTPROGENTAF,
                    OP.VRUNITITEM,
                    ''  AS VRTOTAITEM,
                    '1' AS IDUTILITEM,
                    OP.NRSEQITPROD,
                    OP.IDORIGEMPROD
                  FROM NFRELACAFSAI N,
                    ITEMAUTF I,
                    PRODUTO P,
                    (SELECT R.CDPRARVORIG,
                      R.CDMARCA,
                      SUM(I.QTITEMPROD*I.VRUNITITEM) / SUM(I.QTITEMPROD*(D.VRFATUNEST/C.VRFATUNEST)) AS VRUNITITEM,
                      I.NRSEQITPROD,
                      I.IDORIGEMPROD
                    FROM ITEMPRODUTO I,
                      RELACPRODOL R,
                      CNVPRODUNEST C,
                      CNVPRODUNEST D
                    WHERE I.CDFILIAL  = :P_CDFILIAL
                    AND I.NRLANCTONF  = :P_NRLANCTONF
                    AND I.CDPRODUTO   = D.CDPRUNEST
                    AND D.CDPRODUTO   = C.CDPRODUTO
                    AND R.CDPRODARVOL = C.CDPRUNEST
                    GROUP BY R.CDPRARVORIG,
                      R.CDMARCA,
                      I.NRSEQITPROD,
                      I.IDORIGEMPROD
                    ) OP
                  WHERE N.CDFILIAL                = :P_CDFILIAL
                  AND N.NRLANCTONF                = :P_NRLANCTONF
                  AND N.CDFILDEST                 = I.CDFILDEST
                  AND N.CDFILLANC                 = I.CDFILLANC
                  AND N.NRAUTOFORN                = I.NRAUTOFORN
                  AND N.CDMARCA                   = I.CDMARCA
                  AND N.CDPRODUTO                 = I.CDPRODUTO
                  AND N.DTPROGENTAF               = I.DTPROGENTAF
                  AND I.CDPRODUTO                 = P.CDPRODUTO
                  AND I.CDPRODUTO                 = OP.CDPRARVORIG
                  AND (I.IDBAIXITMAF NOT         IN ('2','3')
                  OR I.IDBAIXITMAF               IS NULL)
                  AND NVL(I.CDMARCAOL, I.CDMARCA) = OP.CDMARCA
                  UNION ALL
                  SELECT P.CDPRODUTO,
                    P.CDARVPROD,
                    P.NMPRODUTO,
                    0                                                                          AS QTSAIDOPLOG,
                    OP.QTITEMPROD                                                              AS QTPROGENTAF,
                    CUSTO_PRODUTO(:P_CDFILDEST, P.CDPRODUTO, :P_TIPOCUSTO, :P_DTPROC, SYSDATE) AS VRPREUNIAF,
                    OP.QTITEMPROD                                                              AS QTNFRELAFSAI,
                    NULL CDFILLANC,
                    NULL CDFILDEST,
                    OP.NRSEQITPROD AS NRAUTOFORN,
                    OP.CDMARCA,
                    SYSDATE AS DTPROGENTAF,
                    OP.VRUNITITEM,
                    ''  AS VRTOTAITEM,
                    '2' AS IDUTILITEM,
                    OP.NRSEQITPROD,
                    OP.IDORIGEMPROD
                  FROM PRODUTO P,
                    (SELECT R.CDPRARVORIG,
                      R.CDMARCA,
                      I.QTITEMPROD,
                      I.VRUNITITEM,
                      I.NRSEQITPROD,
                      I.IDORIGEMPROD
                    FROM ITEMPRODUTO I,
                      RELACPRODOL R
                    WHERE I.CDFILIAL = :P_CDFILIAL
                    AND I.NRLANCTONF = :P_NRLANCTONF
                    AND I.CDPRODUTO  = R.CDPRODARVOL
                    ) OP
                  WHERE P.CDPRODUTO = OP.CDPRARVORIG
                  AND (EXISTS
                    (SELECT 1
                    FROM NFRELACPEXOL
                    WHERE NFRELACPEXOL.CDFILDEST  = :P_CDFILDEST
                    AND NFRELACPEXOL.CDFILIAL     = :P_CDFILIAL
                    AND NFRELACPEXOL.NRLANCTONF   = :P_NRLANCTONF
                    AND NFRELACPEXOL.CDPRODUTO    = P.CDPRODUTO
                    AND NFRELACPEXOL.QTNFRELPEXOL = OP.QTITEMPROD
                    AND NFRELACPEXOL.NRSEQITPEOL  = OP.NRSEQITPROD
                    AND (NFRELACPEXOL.CDMARCA     = OP.CDMARCA)
                    AND (:P_IDUTORIGPROD          = 'N')
                    )
                  OR EXISTS
                    (SELECT 1
                    FROM NFRELACPEXOL
                    WHERE NFRELACPEXOL.CDFILDEST = :P_CDFILDEST
                    AND NFRELACPEXOL.CDFILIAL    = :P_CDFILIAL
                    AND NFRELACPEXOL.NRLANCTONF  = :P_NRLANCTONF
                    AND NFRELACPEXOL.CDPRODUTO   = P.CDPRODUTO
                    AND (NFRELACPEXOL.CDMARCA    = OP.CDMARCA)
                    AND (:P_IDUTORIGPROD         = 'S')
                    ))
                  )
                GROUP BY CDPRODUTO,
                  CDARVPROD,
                  NMPRODUTO,
                  VRPREUNIAF,
                  CDFILLANC,
                  CDFILDEST,
                  NRAUTOFORN,
                  CDMARCA,
                  DTPROGENTAF,
                  VRUNITITEM,
                  IDUTILITEM,
                  NRSEQITPROD,
                  IDORIGEMPROD
                ORDER BY NMPRODUTO";
                
        $params = array("P_CDFILIAL" => $cdFilial,
                        "P_NRLANCTONF" => $nrLanctonf,
                        "P_CDFILDEST" => $cdFildest,
                        "P_TIPOCUSTO" => $tipocusto,
                        "P_DTPROC" => $dtProc,
                        "P_IDUTORIGPROD" => $idutorigprod);
        $query = $this->connection->prepare($sql);
        $query->execute($params);
        return $query->fetchAll();
    }

    // Função para verificar a existência de uma nota fiscal
    public function getNotaFiscal($cdFilDest, $cdFiliOperLog, $nrNotaFisc) {
        $sql = "SELECT CDFILIAL, NRLANCTONF
      FROM NOTAFISCAL
      WHERE CDFILIRECE = :P_CDFILDEST
        AND CDFILIEMIT = :P_CDFILIOPERLOG
        AND IDENTRSAIDOP = 'E'
        AND NRNOTAFISC = :P_NRNOTAFISC";
                
        $params = array(
            "P_CDFILDEST" => $cdFilDest,
            "P_CDFILIOPERLOG" => $cdFiliOperLog,
            "P_NRNOTAFISC" => $nrNotaFisc
        );
        
        $query = $this->connection->prepare($sql);
        $query->execute($params); 
        
        return $query->fetchAll();
    }


   

}
