import {
  Http, IEventParam, Metadata, IDictionary,
} from '@zeedhi/core';
import {
  AlertService, Form, IGridEvent, Modal, ModalService, StateType, LoadingService, Grid,
} from '@zeedhi/common';
import { TekGrid } from '@zeedhi/teknisa-components-common';
import { FileUpload } from '@/services/FileUpload';

export class Dfs48000SaidaDoOperadorLogisticoController {
  private gerarDocumentoModal!: Modal;
  
  private errosSaidaModal!: Modal;
  
  private errosImportacaoModal!: Modal;

  public readOnlySubGrup: StateType = true;

  public readOnlyRota: StateType = true;

  public readOnlyDestPed: StateType = true;

  public readOnlyLote: StateType = true;
  
  public nfOpcao0: StateType = true;
  
  public nfOpcao1: StateType = true;
  
  public showField: StateType = false;
   
  public nfOpcao2: StateType = true;

  public filterValueCDFILIOPELOG: any = {};

  public filterValueCDROTATRANS: Array<any> = [];

  public filterValueCDSUBGRPPROD: Array<any> = [];

  public filterValueCDFILIALDEST: Array<any> = [];

  public filterValueCDLOTENVIOL: Array<any> = [];

  public filterValuePEDOLEXTR: Array<any> = [];

  public filterValueVERIFICACNPJ: any = null;

  public filterValueDTENTREGA: any = {};

  public filterValueSTATUS: Array<any> = [];

  public filterValueDATAENT: any = 0;

  public filterGridFormulario: any = {};

  public filterGridFormularioProduto: any = {};

  public filterGridLancamentoGerado: any = {};

  public filterValueNRINSJUREMPR: any = {};

  public filterValueIDUTILCONSSOLIOL: any = {};

  public filterValueFILCLIE: any = {};

  public periodDisabled: StateType = true;

  public swtDisabled: StateType = false;

  public adqEmpresa: any = {};

  public filterGridForm: any = {};

  public filterValueCDTIPOOPER: any;
  
  public showTabOtherGrids = false;
  
  public isLoadingDefault = false;
  
  public orderDescription = '';
  
  public filterRowPrincipal: any = {};
  
  public logSaida: any;
  
  public modalLogSaida!: Modal;
  
  public modalLog!: Modal;
  
  public modalQReservaProd!: Modal;
  
  public modalImportacaoAjustes!: Modal;

  public async createGerarDocumentoModal() {
    this.gerarDocumentoModal = await ModalService.createFromJson('pages/dfs48000/dfs4800Saida_do_opl_gerar_documento', true);
    this.errosSaidaModal = await ModalService.createFromJson('pages/dfs48000/dfs48000_erros_documento', true);
    this.errosImportacaoModal = await ModalService.createFromJson('pages/dfs48000/dfs48000ErrosImportacao', true);
    this.modalLog = await ModalService.createFromJson('pages/dfs48000/modalLogSaida', true);
    this.createModalLogSaida();
    this.createModalQuestionReservaProduto();
    this.createModalImportacao();
  }

  public destroyGerarDocumentoModal() {
    this.gerarDocumentoModal?.destroy();
    this.errosSaidaModal?.destroy();
    this.errosImportacaoModal?.destroy();
    this.modalLogSaida?.destroy();
    this.modalLog?.destroy();
    this.modalQReservaProd?.destroy();
  }

  public onChangeSwitchRota({ component }: IEventParam<any>) {
    if (this.readOnlyRota) {
      this.filterValueCDROTATRANS = [];
      
      component.parent.children.forEach((child: { name: any; value: any; }) => {
        if (child.name === 'gridSaidasOPL-filter-AND-CONTAINS-CDROTATRANSFILTER-0') {
          child.value = [];
        }
      });
    }
  }

  public onChangeSwitchSubGrup({ component }: IEventParam<any>) {
    if (this.readOnlySubGrup) {
      this.filterValueCDSUBGRPPROD = [];
      
      component.parent.children.forEach((child: { name: any; value: any; }) => {
        if (child.name === 'gridSaidasOPL-filter-AND-CONTAINS-CDSUBGRPRODFILTER-0') {
          child.value = [];
        }
      });
    }
  }

  public onChangeSwitchDestPed({ component }: IEventParam<any>) {
    if (this.readOnlyDestPed) {
      this.filterValueCDFILIALDEST = [];
      
      component.parent.children.forEach((child: { name: any; value: any; }) => {
        if (child.name === 'gridSaidasOPL-filter-AND-CONTAINS-DSFILIALFILTER-0') {
          child.value = 'T';
        }
      });
    }
  }

  public onChangeSwitchLote({ component }: IEventParam<any>) {
    if (this.readOnlyLote) {
      this.filterValueCDLOTENVIOL = [];
      
      component.parent.children.forEach((child: { name: any; value: any; }) => {
        if (child.name === 'gridSaidasOPL-filter-AND-CONTAINS-CDLOTENVITOLFILTER-0') {
          child.value = [];
        }
      });
    }
  }

  public onChangeLote() {
    this.swtDisabled = true;
  }

  public onChangeFieldFilialOL({ component }: any) {
    this.filterValueCDFILIOPELOG = component.value;
    
    const fielddest = component.parent.childrenInstances.filter((field: any) => field.name.includes('DSFILIAL'))[0];
    
    fielddest.datasource.clearFilter();
    
    fielddest.datasource.addFilter('P_CDFILIOPELOG', component.value !== null ? component.value.CDFILIAL : null);
    
    fielddest.datasource.removeOrder('P_CDFILIOPELOG');
    
    fielddest.datasource.data = [];
    
    fielddest.datasource.get();
  }

  public onChangeFieldRotaOL({ component }: any) {
    this.filterValueCDROTATRANS = component.value;
  }

  public onChangeFieldSubgrupoOL({ component }: any) {
    this.filterValueCDSUBGRPPROD = component.value;
  }

  public onChangeFieldFilialDestOL({ component }: any) {
    this.filterValueCDFILIALDEST = component.value;
  }

  public onChangeFieldLoteOL({ component }: any) {
    this.filterValueCDLOTENVIOL = component.value;
  }

  public onChangeFieldStatusPedidoOL({ component }: any) {
    this.filterValuePEDOLEXTR = component.value;
  }

  public onChangeFieldDTEntOL({ component }: any) {
    this.filterValueDATAENT = component.value;
  }

  public onChangeFieldInscrDestOL({ component }: any) {
    this.filterValueVERIFICACNPJ = component.value;
  }

  public onChangeFieldDataEntOL({ component }: any) {
    this.filterValueDTENTREGA = component.value;
  }

  public onChangeFieldTipoOperOL({ component }: any) {
    const form = Metadata.getInstance<Form>('formModalGerarDocumentoAdd');
    const fieldSerie = form.getChildInstance<any>('CDSERIE');
    
    if (component.value !== null) {
      fieldSerie.datasource.filter.P_CDTIPOOPER = component.value.CDTIPOOPER;
      
      fieldSerie.readonly = false;
    } else {
      fieldSerie.datasource.filter.P_CDTIPOOPER = '';
      
      fieldSerie.readonly = true;
    }
    
    fieldSerie.datasource.get();
    
    this.filterValueCDTIPOOPER = component.value;
  }
  
  public onChangeTransportadora({ component }: any) {
    const form = Metadata.getInstance<Form>('formModalGerarDocumentoAdd');
    const fieldPlaca = form.getChildInstance<any>('NRPLACA');
    
    if (component.value !== null) {
      fieldPlaca.datasource.filter.P_NRINSJURTRAN = component.value.NRINSJURTRAN;
      fieldPlaca.datasource.filter.P_IDTPIJURTRAN = component.value.IDTPIJURTRAN;
      
      fieldPlaca.readonly = false;
    } else {
      fieldPlaca.datasource.filter.P_NRINSJURTRAN = '';
      fieldPlaca.datasource.filter.P_IDTPIJURTRAN = '';
      
      fieldPlaca.readonly = true;
    }
    
    fieldPlaca.value = null;
    
    fieldPlaca.datasource.get();
  }

  public onFilterSaidaOpen({ component } : any) {
    LoadingService.show('Carregando...');
    setTimeout(() => {
      const filterButton = document.getElementById('gridSaidasOPL_filterButton_name');
    
      filterButton?.click();
      if (filterButton) {
        setTimeout(() => {
          const campoRota = component.getFilterInputs('ROTASWITCH')[0];
          const campoSubgrupo = component.getFilterInputs('SUBGRUPRODSWITCH')[0];
          const campoDestino = component.getFilterInputs('DESTPEDSWITCH')[0];
          const campoLote = component.getFilterInputs('LOTESWITCH')[0];
          const campoStatusPed = component.getFilterInputs('PEDOLEXTR')[0];
          const campoDataCons = component.getFilterInputs('DATAENT')[0];
          const campoCnpj = component.getFilterInputs('VERIFICACNPJ')[0];
          const campoNfOp0 = component.getFilterInputs('NFOP0')[0];
          const campoNfOp1 = component.getFilterInputs('NFOP1')[0];
          const campoNfOp2 = component.getFilterInputs('NFOP2')[0];
      
          campoRota.value = false;
          campoSubgrupo.value = false;
          campoDestino.value = false;
          campoRota.isVisible = false;
          campoSubgrupo.isVisible = false;
          campoDestino.isVisible = false;
          campoLote.value = true;
          campoNfOp0.value = true;
          campoNfOp1.value = true;
          campoNfOp2.value = true;
          campoStatusPed.value = [
            {
              id: 'S',
              value: 'Extra',
            },
            {
              id: 'N',
              value: 'Não Extra',
            },
          ];
          campoDataCons.setValue(
            {
              name: 'Data de Entrega',
              value: 0,
            },
          );
          campoCnpj.setValue(
            {
              name: 'Desconsidera',
              value: null,
            },
          );
        }, 400);
      }
   
      LoadingService.hide();
    }, 400);
  }

  public formater(array: Array<any>) {
    return array.length !== 0 ? String('_').concat(array.join('_').concat(String('_'))) : 'T';
  }

  public async getInfo(datasourcefilter: string) {
    return Http.get(datasourcefilter);
  }

  public async onFilterload() {
    const grid = Metadata.getInstance<any>('gridSaidasOPL');
    const arrayCDFILIDEST = typeof grid.datasource.dynamicFilter.DSFILIALFILTER !== 'undefined' ? grid.datasource.dynamicFilter.DSFILIALFILTER[0].value.map((f: any) => f.CDFILIAL) : [];
    const arrayCDSUBGRPPROD = typeof grid.datasource.dynamicFilter.CDSUBGRPRODFILTER !== 'undefined' ? grid.datasource.dynamicFilter.CDSUBGRPRODFILTER[0].value.map((f: any) => f.CDSUBGRPROD) : [];
    const arrayCDROTATRANS = typeof grid.datasource.dynamicFilter.CDROTATRANSFILTER !== 'undefined' ? grid.datasource.dynamicFilter.CDROTATRANSFILTER[0].value.map((f: any) => f.CDROTATRANS) : [];
    const arrayCDLOTENVIOL = typeof grid.datasource.dynamicFilter.CDLOTENVITOLFILTER !== 'undefined' ? grid.datasource.dynamicFilter.CDLOTENVITOLFILTER[0].value.map((f: any) => f.CDLOTENVITOL) : [];
    const arrayPEDOLEXTR = this.filterValuePEDOLEXTR.length === 2 ? 'T' : this.filterValuePEDOLEXTR.map((f: any) => f.id);
    const nrinsjDatasource = 'crudN/dfs48000adqEmpresa?in=CDFILIOPELOG&CDFILIOPELOG='.concat(this.filterValueCDFILIOPELOG.CDFILIAL);
    const clienteExtDatasource = 'crudN/dfs48000adqclienteExt?in=CDFILIOPELOG&CDFILIOPELOG='.concat(this.filterValueCDFILIOPELOG.CDFILIAL);
    const utilConsOLDatasource = 'crudN/dfs48000adqParaSupri?in=CDFILIOPELOG&CDFILIOPELOG='.concat(this.filterValueCDFILIOPELOG.CDFILIAL);

    this.filterValueNRINSJUREMPR = await this.getInfo(nrinsjDatasource);
    this.filterValueFILCLIE = await this.getInfo(clienteExtDatasource);
    this.filterValueIDUTILCONSSOLIOL = await this.getInfo(utilConsOLDatasource);
    
    this.showField = this.filterValueIDUTILCONSSOLIOL.data.data[0].IDUTRESPEDEXOL === 'S';
    
    const arraySTATUS = [];
    
    if (this.nfOpcao0 === true) {
      arraySTATUS.push('0');
    }
    if (this.nfOpcao1 === true) {
      arraySTATUS.push('9');
    }
    if (this.nfOpcao2 === true) {
      arraySTATUS.push('1');
      arraySTATUS.push('2');
    }

    const filterFilial = {
      P_CDLOTENVIOL: this.formater(arrayCDLOTENVIOL),
      P_PEDOLEXTR: arrayPEDOLEXTR === 'T' ? 'T' : this.formater(arrayPEDOLEXTR),
      P_NRSJUREMPR: this.filterValueNRINSJUREMPR.data.data[0].NRINSJUREMPR,
      P_DATAENT: this.filterValueDATAENT.value,
      P_DTENTREGA: this.filterValueDTENTREGA,
      P_FILOPELOG: grid.datasource.dynamicFilter.CDFILIOPELOG[0].value.CDFILIAL,
      P_CDFILIAL: this.formater(arrayCDFILIDEST),
      P_ROTA: arrayCDROTATRANS.length > 0 ? this.formater(arrayCDROTATRANS) : null,
      P_FILCLIE: this.filterValueFILCLIE.data.data[0].CDCLIENTEEXT !== '0' ? 'L' : 'C',
      P_SUBGRUPO: this.formater(arrayCDSUBGRPPROD),
      P_VERIFICACNPJ: this.filterValueVERIFICACNPJ.value,
      P_CDCLIENTE: this.formater(arrayCDFILIDEST) === 'T' ? 'T' : null,
      P_STATUS: this.formater(arraySTATUS),
      P_IDUTILCONSSOLIOL: this.filterValueIDUTILCONSSOLIOL.data.data[0].IDUTILCONSSOLIOL,
    };
    
    this.filterRowPrincipal = filterFilial;

    grid.datasource.filter = filterFilial;
    grid.datasource.get();
  }

  public async loadGridFormulario(params: any) {
    const row = {
      CDFILIOPELOG: this.filterValueCDFILIOPELOG.CDFILIAL,
      DTENTRSAID: this.filterValueDTENTREGA,
    };
    
    Http.post('getDtProcessaOpl', { requestType: 'Row', row }).then((response) => {
      const gridFormulario = Metadata.getInstance<TekGrid>('gridFormulario');
      const filterGridFormulario = {
        P_CDFILLANC: params.row.CDFILLANC,
        P_FILOPELOG: this.filterValueCDFILIOPELOG.CDFILIAL,
        P_NRAUTOFORN: params.row.NRAUTOFORN,
        P_SUBGRUPO: 'T',
        P_DATAENT: this.filterValueDATAENT.value,
        P_DTENTREGA: this.filterValueDTENTREGA,
        P_DTPROC: response.data.dataset.res[1].DTPROCESSA,
        P_PEDOLEXTR: 'T',
        P_CDLOTENVIOL: 'T',
        P_IDBAIXAOLSAI: 'T',
        P_IDUTILCONSSOLIOL: this.filterValueIDUTILCONSSOLIOL.data.data[0].IDUTILCONSSOLIOL,
        P_FILDEST: params.row.CDFILIAL,
      };
      
      gridFormulario.datasource.filter = filterGridFormulario;
      gridFormulario.datasource.get();
    });
  }

  public loadGridFormularioProduto({ component }: any) {
    component.datasource.route = 'crudN/dfs48000gridSaidaOplFormularioProduto';

    component.datasource.filter = this.filterGridFormularioProduto;
    component.datasource.get();
  }

  public loadGridLancamentoGerado(params: any) {
    const gridLancamento = Metadata.getInstance<TekGrid>('gridLancamento');
    const filterGridLancamentoGerado = {
      P_CDFILDEST: params.row.CDFILIAL,
      P_DTENTREGA: this.filterValueDTENTREGA,
      P_CDFILLANC: params.row.CDFILLANC,
      P_NRAUTOFORN: params.row.NRAUTOFORN,
      P_DATAENT: this.filterValueDATAENT.value,
      P_CDLOTENVIOL: 'T',
      P_SUBGRUPO: 'T',
    };

    gridLancamento.datasource.filter = filterGridLancamentoGerado;
    gridLancamento.datasource.get().then((response) => {
      if (response.length > 0) {
        const gridLancamentoProdutos = Metadata.getInstance<TekGrid>('gridProdutosLancamento');
        const filterGridLancamentoGeradoProdutos = {
          P_CDFILIAL: response[0].CDFILIAL,
          P_NRLANCTONF: response[0].NRLANCTONF,
        };
    
        gridLancamentoProdutos.datasource.filter = filterGridLancamentoGeradoProdutos;
        gridLancamentoProdutos.datasource.get();
      }
    });
  }

  public onChangeCdfiliOl({ component }: IEventParam<any>) {
    const fieldValueDestino = component.parent.getElementById('CDFILIALDEST');

    fieldValueDestino.datasource.filter.P_CDFILIOPELOG = component.value.CDFILIAL;

    fieldValueDestino.datasource.get();
  }

  public abrirModalGerarDocumento() {
    const grid = Metadata.getInstance<IGridEvent>('gridSaidasOPL');
    const selectedRows = grid.selectedRows;

    // Mostrar indicador de carregamento
    LoadingService.show('Carregando...');

    if (selectedRows.length > 0) {
      // Mostrar o modal
      this.gerarDocumentoModal.show();

      setTimeout(() => {
        const form = Metadata.getInstance<Form>('formModalGerarDocumentoAdd');
        const fieldTipoOper = form.getChildInstance<any>('CDTIPOOPER');
        const fieldTransprt = form.getChildInstance<any>('NMRAZSOCTRAN');
        const fieldSerie = form.getChildInstance<any>('CDSERIE');
        const fieldData = form.getChildInstance<any>('DATA');
        const fieldFrete = form.getChildInstance<any>('FRETE');
        const unidades: any[] = [];

        // Definir valor inicial do campo Frete
        fieldFrete.value = {
          CDFRETE: 9,
          DSFRETE: 'Sem ocorrência de Transporte',
        };

        selectedRows.forEach((row: any) => {
          unidades.push(row.CDFILIAL);
        });

        // Configurar filtros para os campos Transporte e Série
        fieldTransprt.datasource.filter.P_CDFILIALOL = this.filterValueCDFILIOPELOG.CDFILIAL;
        fieldSerie.datasource.filter.P_CDFILIALOL = this.filterValueCDFILIOPELOG.CDFILIAL;

        const unStr = unidades.join('_');
        const unidadesString = String('_').concat(String(unStr).concat(String('_')));

        const row = {
          CDFILIOPELOG: this.filterValueCDFILIOPELOG.CDFILIAL,
          DTENTRSAID: this.filterValueDTENTREGA,
        };

        // Primeira chamada à API para obter dados de cliente externo
        Http.get(`crudN/dfs48000_clienteext?in=P_CDFILIOPELOG&P_CDFILIOPELOG=${this.filterValueCDFILIOPELOG.CDFILIAL}`).then((response) => {
          // Segunda chamada à API para obter dados de tipo de operação
          Http.get(`crudN/dfs48000_tipooper_param?in=P_CDFILIOPELOG&in=P_CDFILIAL&P_CDFILIOPELOG=${this.filterValueCDFILIOPELOG.CDFILIAL}&P_CDFILIAL=${unidadesString}`).then((response1) => {
            // Terceira chamada à API para obter a data de processamento
            Http.post('getDtProcessaOpl', { requestType: 'Row', row }).then((response2) => {
              // Verificar a mensagem retornada e definir o valor do campo Data
              if (response2.data.dataset.res[0].MESSAGE === null) {
                fieldData.value = this.filterValueDTENTREGA;
              } else {
                fieldData.value = response2.data.dataset.res[1].DTPROCESSA;
              }

              // Verificar os dados de tipo de operação retornados
              if (response1.data.data.length > 0) {
                fieldTipoOper.setValue(response1.data.data[0].CDTIPOOPERSAID);
                fieldTipoOper.readonly = true;
                fieldTipoOper.isVisible = false;
                
                fieldTipoOper.datasource.get().then(() => {
                  LoadingService.hide();
                });
              } else {
                if (response.data.data.length === 0) {
                  let cont = 0;

                  // Verificar se existem clientes externos
                  response.data.data.forEach((r: any) => {
                    if (r.CDCLIENTEEXT !== null) {
                      cont += 1;
                    }
                  });

                  // Atualizar os filtros do campo Tipo de Operação com base nos clientes externos
                  if (cont === 0) {
                    // fieldTipoOper.datasource.filter.P_CDTIPOOPER = '02';
                    // fieldTipoOper.datasource.filter.P_IDORIGDESTOP = 'L';
                  } else {
                    fieldTipoOper.datasource.filter.P_CDTIPOOPER = '';
                    fieldTipoOper.datasource.filter.P_IDORIGDESTOP = 'C';
                  }

                  fieldTipoOper.datasource.get().then(() => {
                    fieldTipoOper.setValue('02');
                    LoadingService.hide();
                  });
                } else {
                  // Configurar filtros padrão para o campo Tipo de Operação
                  // fieldTipoOper.datasource.filter.P_CDTIPOOPER = '02';
                  // fieldTipoOper.datasource.filter.P_IDORIGDESTOP = 'L';

                  fieldTipoOper.datasource.get().then(() => {
                    LoadingService.hide();
                    fieldTipoOper.setValue('02');
                  });
                }
                fieldTipoOper.readonly = false;
              }
            });
          });
        });
      }, 1000);
    } else {
      // Ocultar indicador de carregamento e mostrar alerta se nenhuma unidade foi selecionada
      LoadingService.hide();
      AlertService.show({
        top: true,
        right: true,
        timeout: 1000,
        name: 'notCheckedAltert',
        text: 'Deve ser marcado pelo menos uma unidade para a geração de saída.',
        color: 'error',
      });
    }
  }

  public fecharModalGerarDocumento() {
    this.gerarDocumentoModal.hide();
  }
  
  public fecharModalErrosSaida() {
    this.errosSaidaModal.hide();
  }
  
  public fecharModalErrosImportacao() {
    this.errosImportacaoModal.hide();
  }

  public selectRowsFormulario() {
    const gridProduto = Metadata.getInstance<IGridEvent>('gridSaidasOPL');
    const arrayGrid = gridProduto.datasource.currentRowValue;
    return arrayGrid;
  }

  public selectRowslancGerado() {
    const gridNotaFiscal = Metadata.getInstance<IGridEvent>('grid-formulario-OPL');
    const arrayGrid = gridNotaFiscal.datasource.currentRowValue;
    return arrayGrid;
  }
  
  public async createModalLogSaida() {
    this.modalLogSaida = ModalService.create({
      name: 'modalLogSaida',
      title: 'Log da Geração de Saída do OPL',
      persistent: true,
      children: [
        {
          name: 'PersistentModalForm',
          component: 'ZdForm',
          children: [
            {
              name: 'textLog',
              component: 'ZdText',
              text: null,
            },
          ],
        },
        {
          name: 'closeModalButton',
          component: 'ZdButton',
          label: 'Fechar',
          events: {
            click: '{{Dfs48000SaidaDoOperadorLogisticoController.closeModalLogSaida}}',
          },
        },
      ],
    });
  }
  
  public closeModalLogSaida() {
    this.modalLogSaida.hide();
  }

  public closeModalLog() {
    this.modalLog.hide();
  }

  public salvarModalGerarDocumento() {
    const grid = Metadata.getInstance<TekGrid>('gridSaidasOPL');
    const rows = grid.selectedRows;
    const form = Metadata.getInstance<Form>('formModalGerarDocumentoAdd');
    let noErro = true;
    const valid = form.validate();
    const row = {
      NFS: rows,
      DADOSGERACAO: form.value,
    };
    
    row.DADOSGERACAO.CDFILIOPELOG = this.filterValueCDFILIOPELOG.CDFILIAL;
    row.DADOSGERACAO.SUBGRUPO = this.filterRowPrincipal.P_SUBGRUPO;
    row.DADOSGERACAO.DATAENT = this.filterRowPrincipal.P_DATAENT;
    row.DADOSGERACAO.DTENTREGA = this.filterRowPrincipal.P_DTENTREGA;
    row.DADOSGERACAO.PEDOLEXTR = this.filterRowPrincipal.P_PEDOLEXTR;
    row.DADOSGERACAO.CDLOTENVITOL = this.filterRowPrincipal.P_CDLOTENVIOL;
    row.DADOSGERACAO.IDUTILCONSSOLIOL = this.filterRowPrincipal.P_IDUTILCONSSOLIOL;
    row.DADOSGERACAO.IDUTRESPEDXOL = this.filterValueIDUTILCONSSOLIOL.data.data[0].IDUTRESPEDEXOL;
    row.DADOSGERACAO.GERANF = 'S';
    
    if (!valid) {
      AlertService.show({
        top: true,
        right: true,
        timeout: 2000,
        name: 'invalidoAltert',
        text: 'Preencha todos os campos obrigatórios!',
        color: 'error',
      });
    } else {
      form.submit();
      
      LoadingService.show('Carregando...');
      
      const data = {
        DSFILIAL: rows[0].DSFILIAL,
        CDPEDIDO: rows[0].USR_NRPEDIDO,
        CDPRODUTO: '',
        DSERRO: '',
      };
      
      Http.post('/validaItensPedido', { requestType: 'Row', row }).then((resp) => {
        this.logSaida = resp.data.dataset.saidaEntrada;
        
        if (resp.data.dataset.pedErros.length === 0) {
          LoadingService.hide();
          
          if (this.logSaida.NFS_ERRO.length > 0 || this.logSaida.NFS_SUCESSO.length > 0) {
            if (this.logSaida.NFS_ERRO.length > 0) {
              noErro = false;
              this.modalLog.show();
            }
            // else {
            //   this.modalLogSaida.show();
            // }
              
            setTimeout(() => {
            //   let log = '';
              
              //   if (this.logSaida.NFS_SUCESSO.length > 0) {
              //     const textLog = Metadata.getInstance<any>('textLog');
              //     log += 'Notas Geradas com sucesso: <br>';
                
              //     this.logSaida.NFS_SUCESSO.forEach((ns: any) => {
              //       log += `<span style="display: inline-block; margin-left: 40px;"></span>Nota:  ${ns.NRLANCTONF}, Un. Dest.:
              //       ${ns.CDFILDEST}, Op. Logístico: ${ns.CDFILIOPELOG} - ${ns.NMFILIOPELOG}, Dt. Entrega: ${ns.DTENTREGA}, Dt. Saída: ${ns.DTSAIDA} <br>`;
              //     });
              //     textLog.text = log;
              //   }
              
              if (this.logSaida.NFS_ERRO.length > 0) {
                // log += 'Notas que não foram geradas: <br>';
              
                const gridErro = Metadata.getInstance<Grid>('gridErro');

                this.logSaida.NFS_ERRO.forEach((ns: any) => {
                  // log += `<span style="display: inline-block; margin-left: 40px;"></span>Nota:  ${ns.NRLANCTONF}, Un. Dest.:
                  // ${ns.CDFILDEST}, Op. Logístico: ${ns.CDFILIOPELOG} - ${ns.NMFILIOPELOG}, Dt. Entrega: ${ns.DTENTREGA}, Dt. Saída: ${ns.DTSAIDA} <br>`;
                  
                  // if (ns.DSERRO !== null) {
                  //   log += `<span style="display: inline-block; margin-left: 40px;"></span>
                  //           Erro: ${ns.DSERRO} <br>`;
                  // }
                  if (ns.DSERRO) {
                    data.DSERRO = ns.DSERRO;
                  }
                  
                  if (ns.PROD_ERRO.length > 0) {
                    ns.PROD_ERRO.forEach((np: any) => {
                      if (np.NRLANCTONF === ns.NRLANCTONF) {
                        data.CDPRODUTO = `${this.applyMask(np.CDARVPRODOL)} - ${np.NMPRODUTOOL}`;
                        data.DSERRO = np.DSERRO;
                        // log += `<span style="display: inline-block; margin-left: 40px;"></span><span style="display: inline-block; margin-left: 40px;"></span>
                        // Produto OL: ${np.CDARVPRODOL} - ${np.NMPRODUTOOL}, Produto Estoque: ${np.CDARVPRODEST} - ${np.NMPRODUTOEST} <br>
                        // <span style="display: inline-block; margin-left: 40px;"></span><span style="display: inline-block; margin-left: 40px;"></span>
                        // Erro: ${np.DSERRO}`;
                      }
                    });
                  }
                });
                gridErro.datasource.updateData([data]);
              }
            }, 100);
          }
        } else {
          this.errosSaidaModal.show();
          
          setTimeout(() => {
            const gridErros = Metadata.getInstance<TekGrid>('gridErrosGeracaoSaida');
            
            gridErros.datasource.data = [];
            
            (gridErros as any).datasource.allData = [];
            
            gridErros.datasource.post(resp.data.dataset.pedErros).then(() => {
              gridErros.datasource.get();
              
              LoadingService.hide();
            });
            
            if (this.logSaida.NFS_ERRO.length > 0 || this.logSaida.NFS_SUCESSO.length > 0) {
              if (this.logSaida.NFS_ERRO.length > 0) {
                this.modalLog.show();
                noErro = false;
              }
              
              setTimeout(() => {
                // let log = '';
                // const textLog = Metadata.getInstance<any>('textLog');

                // if (this.logSaida.NFS_SUCESSO.length > 0) {
                //   log += 'Notas Geradas com sucesso: <br>';
                  
                //   this.logSaida.NFS_SUCESSO.forEach((ns: any) => {
                //     log += `<span style="display: inline-block; margin-left: 40px;"></span>Nota:  ${ns.NRLANCTONF}, Un. Dest.:
                //     ${ns.CDFILDEST}, Op. Logístico: ${ns.CDFILIOPELOG} - ${ns.NMFILIOPELOG}, Dt. Entrega: ${ns.DTENTREGA}, Dt. Saída: ${ns.DTSAIDA} <br>`;
                //   });
                // }
                
                if (this.logSaida.NFS_ERRO.length > 0) {
                  // log += 'Notas que não foram geradas: <br>';
                  const gridErro = Metadata.getInstance<Grid>('gridErro');

                  this.logSaida.NFS_ERRO.forEach((ns: any) => {
                    // log += `<span style="display: inline-block; margin-left: 40px;"></span>Nota:  ${ns.NRLANCTONF}, Un. Dest.:
                    // ${ns.CDFILDEST}, Op. Logístico: ${ns.CDFILIOPELOG} - ${ns.NMFILIOPELOG}, Dt. Entrega: ${ns.DTENTREGA}, Dt. Saída: ${ns.DTSAIDA} <br>`;
                    
                    // if (ns.DSERRO !== null) {
                    //   log += `<span style="display: inline-block; margin-left: 40px;"></span>
                    //           Erro: ${ns.DSERRO} <br>`;
                    // }
                    
                    if (ns.PROD_ERRO.length > 0) {
                      ns.PROD_ERRO.forEach((np: any) => {
                        if (np.NRLANCTONF === ns.NRLANCTONF) {
                          data.CDPRODUTO = `${this.applyMask(np.CDARVPRODOL)} - ${np.NMPRODUTOOL}`;
                          data.DSERRO = np.DSERRO;
                          // log += `<span style="display: inline-block; margin-left: 40px;"></span><span style="display: inline-block; margin-left: 40px;"></span>
                          // Produto OL: ${np.CDARVPRODOL} - ${np.NMPRODUTOOL}, Produto Estoque: ${np.CDARVPRODEST} - ${np.NMPRODUTOEST} <br>
                          // <span style="display: inline-block; margin-left: 40px;"></span><span style="display: inline-block; margin-left: 40px;"></span>
                          // Erro: ${np.DSERRO}`;
                        }
                      });
                    }
                  });
                  gridErro.datasource.updateData([data]);
                  // textLog.text = log;
                }
              }, 1);
            }
            
            LoadingService.hide();
          }, 100);
        }
        if (noErro) {
          const grida = Metadata.getInstance<TekGrid>('gridSaidasOPL');
          this.fecharModalGerarDocumento();
          grida.datasource.get();
        }
      }).catch(() => {
        LoadingService.hide();
      });
    }
  }
  
  public applyMask(value: any, mask = '#.##.##.###.##') {
    let maskedValue = '';
    let valueIndex = 0;

    for (let i = 0; i < mask.length; i += 1) {
      if (mask[i] === '#') {
        maskedValue += value[valueIndex] || '';
        valueIndex += 1;
      } else {
        maskedValue += mask[i];
      }
    }

    return maskedValue;
  }
  
  // public showFields({ event, component }: IGridEvent) {
  //   console.log(component);
  // }
  
  public getConditionalCssClassIdStatusS({ row } : IDictionary<any>) {
    if (row.IDSTATUS === '9') {
      return 'yellow-row';
    }
    if (row.IDSTATUS === '2' || row.IDSTATUS === '1') {
      return 'green-row';
    }
    if (row.IDSTATUS === '0') {
      return 'white-row';
    }
    return 'white-row';
  }
  
  public getConditionalCssClassIdStatusE({ row } : IDictionary<any>) {
    if (row.IDSTATUSE === '9') {
      return 'yellow-row';
    }
    if (row.IDSTATUSE === '2' || row.IDSTATUSE === '1') {
      return 'green-row';
    }
    if (row.IDSTATUSE === '0') {
      return 'white-row';
    }
    return 'white-row';
  }
  
  public changeValueOfLote({ row }: IDictionary<any>) {
    if (row.CDLOTENVITOL === 'T') {
      row.CDLOTENVITOL = 'Sem Lote';
    }
  }
  
  get isVisibleGridSaidasOPL() {
    return !this.showTabOtherGrids;
  }
  
  public cellClick(params: any) {
    this.showTabOtherGrids = true;
    
    this.isLoadingDefault = false;
    
    this.orderDescription = String(params.row.NRAUTOFORN).concat(String(' - Unidade: ').concat(params.row.DSFILIAL));
    
    this.loadGridFormulario(params);
    this.loadGridLancamentoGerado(params);
  }
  
  public clickBackToPrincipalGrid() {
    this.showTabOtherGrids = false;
  }
  
  public async verifyDtProcessa({ component }: IEventParam<any>) {
    const row = {
      CDFILIOPELOG: this.filterValueCDFILIOPELOG.CDFILIAL,
      DTENTRSAID: component.value !== null ? component.value : this.filterValueDTENTREGA,
    };
    
    LoadingService.show('Carregando...');
    
    await Http.post('getDtProcessaOpl', { requestType: 'Row', row }).then((resp) => {
      if (resp.data.dataset.res !== undefined) {
        if (resp.data.dataset.res[0].MESSAGE === 'Data_Mai') {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'Data_Mai',
            text: 'Data informada não deve ser maior que a data de processamento.',
            color: 'warning',
          });
          
          component.value = resp.data.dataset.res[1].DTPROCESSA;
        }
        if (resp.data.dataset.res[0].MESSAGE === 'Data_Men') {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'Data_Men',
            text: 'Data informada não deve ser menor que a data de processamento.',
            color: 'warning',
          });
          
          component.value = resp.data.dataset.res[1].DTPROCESSA;
        }
        if (resp.data.dataset.res[0].MESSAGE === 'Data_M') {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'Data_M',
            text: 'Data informada fora do período permitido',
            color: 'warning',
          });
          
          component.value = resp.data.dataset.res[1].DTPROCESSA;
        }
        if (resp.data.dataset.res[0].MESSAGE === 'Sem_Serie') {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'Sem_Serie',
            text: 'Unidade OL sem série padrão cadastrada',
            color: 'warning',
          });
          
          component.value = resp.data.dataset.res[1].DTPROCESSA;
        }
      }
      
      LoadingService.hide();
    });
  }
  
  public lancamentoRowClick({ row }: IGridEvent) {
    const gridLancamentoProdutos = Metadata.getInstance<TekGrid>('gridProdutosLancamento');
    const filterGridLancamentoGeradoProdutos = {
      P_CDFILIAL: row.CDFILIAL,
      P_NRLANCTONF: row.NRLANCTONF,
    };

    gridLancamentoProdutos.datasource.filter = filterGridLancamentoGeradoProdutos;
    gridLancamentoProdutos.datasource.get();
  }
  
  public changeNfOpcao0({ component }: any) {
    if ((this.nfOpcao1 === null || this.nfOpcao1 === false) && (this.nfOpcao2 === null || this.nfOpcao2 === false)) {
      setTimeout(() => {
        this.nfOpcao0 = true;
        
        component.value = true;
      }, 100);
    }
  }
  
  public changeNfOpcao1({ component }: any) {
    if ((this.nfOpcao0 === null || this.nfOpcao0 === false) && (this.nfOpcao2 === null || this.nfOpcao2 === false)) {
      setTimeout(() => {
        this.nfOpcao1 = true;
        
        component.value = true;
      }, 100);
    }
  }
  
  public changeNfOpcao2({ component }: any) {
    if ((this.nfOpcao0 === null || this.nfOpcao0 === false) && (this.nfOpcao1 === null || this.nfOpcao1 === false)) {
      setTimeout(() => {
        this.nfOpcao2 = true;
        
        component.value = true;
      }, 100);
    }
  }
  
  public fecharModalModalQuestionReservaProduto() {
    this.modalQReservaProd.hide();
  }
  
  public async createModalQuestionReservaProduto() {
    this.modalQReservaProd = await ModalService.create({
      name: 'modalQReservaProd',
      title: 'Deseja prosseguir com a operação?',
      persistent: true,
      children: [
        {
          name: 'footerQReservaProd',
          component: 'ZdFooter',
          color: 'transparent',
          padless: true,
          leftSlot: [
            {
              name: 'cancelButton',
              component: 'ZdButton',
              label: 'Cancelar',
              outline: true,
              events: {
                click: '{{Dfs48000SaidaDoOperadorLogisticoController.fecharModalModalQuestionReservaProduto}}',
              },
            },
          ],
          rightSlot: [
            {
              name: 'saveButton',
              component: 'ZdButton',
              label: 'Continuar',
              events: {
                click: '{{Dfs48000SaidaDoOperadorLogisticoController.confirmaIncluiReservaProduto}}',
              },
            },
          ],
        },
      ],
    });
  }
  
  public openQuestionReservaProduto() {
    this.modalQReservaProd.show();
  }
  
  public async confirmaIncluiReservaProduto() {
    const row = this.filterRowPrincipal;
    
    LoadingService.show('Carregando...');
    
    await Http.post('procedureIncluiReservaOL', { requestType: 'Row', row }).then((response) => {
      if (response.data.dataset.result.P_ROWSAFFECT === 'S') {
        AlertService.show({
          top: true,
          right: true,
          timeout: 2000,
          name: 'SuccessOperation',
          text: 'Operação realizada com sucesso.',
          color: 'success',
        });
        
        this.modalQReservaProd.hide();
        
        LoadingService.hide();
      } else {
        AlertService.show({
          top: true,
          right: true,
          timeout: 2000,
          name: 'FailedOperation',
          text: 'Houve um problema ao executar a operação.',
          color: 'error',
        });
        
        LoadingService.hide();
      }
    }).catch(() => {
      AlertService.show({
        top: true,
        right: true,
        timeout: 2000,
        name: 'FailedOperation',
        text: 'Houve um problema ao executar a operação.',
        color: 'error',
      });
      
      LoadingService.hide();
    });
  }
  
  public fecharModalModalImportacaoAjustes() {
    this.modalImportacaoAjustes.hide();
  }
  
  public async createModalImportacao() {
    this.modalImportacaoAjustes = await ModalService.create({
      name: 'modalImportacaoAjustes',
      title: 'Importação de Ajustes do Pedido do OL',
      persistent: true,
      children: [
        {
          component: 'ZdForm',
          name: 'formImportacaoAjustes',
          children: [
            {
              name: 'fileInputImportacaoAjustes',
              component: 'ZdFileInput',
              label: 'Arquivo',
              maxFiles: 1,
              type: 'multipart/form-data',
              accept: '.txt',
              placeholder: 'Selecione um arquivo...',
              validations: {
                required: true,
              },
              grid: {
                sm: 12,
                lg: 10,
              },
            },
          ],
        },
        {
          name: 'footerImportacaoAjustes',
          component: 'ZdFooter',
          color: 'transparent',
          padless: true,
          leftSlot: [
            {
              name: 'cancelButtonImportacaoAjustes',
              component: 'ZdButton',
              label: 'Cancelar',
              outline: true,
              events: {
                click: '{{Dfs48000SaidaDoOperadorLogisticoController.fecharModalModalImportacaoAjustes}}',
              },
            },
          ],
          rightSlot: [
            {
              name: 'saveButtonImportacaoAjustes',
              component: 'ZdButton',
              label: 'Continuar',
              events: {
                click: '{{Dfs48000SaidaDoOperadorLogisticoController.confirmarImportacao}}',
              },
            },
          ],
        },
      ],
    });
  }
  
  public openModalImportacao() {
    this.modalImportacaoAjustes.show();
    
    setTimeout(() => {
      const form = Metadata.getInstance<Form>('formImportacaoAjustes');
      
      form.clearForm();
    }, 1);
  }
  
  public async confirmarImportacao() {
    const form = Metadata.getInstance<Form>('formImportacaoAjustes');
    const valid = form.validate();
    const field: any = Metadata.getInstance('fileInputImportacaoAjustes');
    
    if (!valid) {
      AlertService.show({
        top: true,
        right: true,
        timeout: 2000,
        name: 'formInvalidoAlert',
        text: 'Preencha todos os campos obrigatórios!',
        color: 'error',
      });
    } else {
      const fieldFileValue = await FileUpload.getFileContent(field.value);
      const row = {
        ITENS: fieldFileValue.content[0],
        FILTRO: this.filterRowPrincipal,
      };
      
      LoadingService.show('Carregando...');
    
      await Http.post('importaAjustesPedidoOL', { requestType: 'Row', row }).then((response) => {
        if (response.data.dataset.itens_erros.length > 0) {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'itenErrosAlert',
            text: `Processo concluído com ${response.data.dataset.itens_erros.length} itens não importados.`,
            color: 'warning',
          });
          this.errosImportacaoModal.show();
          
          setTimeout(() => {
            const gridErros = Metadata.getInstance<any>('gridErrosImportacao');
            
            gridErros.datasource.data = [];
            
            (gridErros as any).datasource.allData = [];
            
            gridErros.datasource.post(response.data.dataset.itens_erros).then(() => {
              gridErros.datasource.get();
              
              LoadingService.hide();
            });
          }, 10);
        } else {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'SuccessOperation',
            text: 'Operação realizada com sucesso.',
            color: 'success',
          });
          
          this.modalImportacaoAjustes.hide();
        
          LoadingService.hide();
        }
      }).catch(() => {
        AlertService.show({
          top: true,
          right: true,
          timeout: 2000,
          name: 'FailedOperation',
          text: 'Houve um problema ao executar a operação.',
          color: 'error',
        });
        
        LoadingService.hide();
      });
    }
  }
  
  public openPrintPage() {
    window.top.postMessage({
      type: 'openPrintPage',
      realData: null,
    }, window.location.ancestorOrigins[0]);
  }
}
